﻿

using Consola.Dominio;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
namespace Consola
{
    class Program
    {


        private static Tipo MetodoGenerico<Tipo>(Tipo parametro)
        {
            return parametro;
        }

        static void Main(string[] args)
        {
            
            // Arrays

            byte[,,] arreglo = new byte[2, 5, 10];

            arreglo[0, 0, 0] = 1;
            arreglo[0, 2, 0] = 2;

            byte[] arreglo2 = new byte[] { 0, 1, 2, 3 };

            System.Array arreglo3 = System.Array.CreateInstance(typeof (byte), 10);

            for (int i = 0; i < arreglo.Length; i++)
            {
                //byte valor = arreglo[i, 0, 0];
                //System.Console.WriteLine(valor);
            }

            //System.Console.ReadLine();

            // ArrayList


            System.Collections.ArrayList arregloDinamico = new ArrayList();

            arregloDinamico.Add(100);
            arregloDinamico.Add("Hola");
            arregloDinamico.Add(System.DateTime.Today);

            arregloDinamico.RemoveAt(1);

            for (int i = 0; i < arregloDinamico.Count; i++)
            {
                //System.Console.WriteLine(arregloDinamico[i]);
            }

            //System.Console.ReadLine();

            // Generics

            var texto = "Hola Mundo";
            var numero = 1000;

            var resultado1 = MetodoGenerico(texto);

            var resultado2 = MetodoGenerico(numero);

            // Colas

            System.Collections.Generic.Queue<int> cola;
            cola = new Queue<int>();

            cola.Enqueue(100);
            cola.Enqueue(200);
            cola.Enqueue(300);

            //System.Console.WriteLine(cola.Peek());

            //System.Console.WriteLine(cola.Dequeue());
            //System.Console.WriteLine(cola.Dequeue());
            //System.Console.WriteLine(cola.Dequeue());

            //System.Console.ReadLine();

            // Pilas

            Stack<string> pila = new Stack<string>();

            pila.Push("Hola");
            pila.Push("Mundo");

            //Console.WriteLine(pila.Pop());
            //Console.WriteLine(pila.Pop());

            //Console.ReadLine();

            // Listas

          
            List<string> lista = new List<string>();

            lista.Add("hola mundo");
            lista.Add("hola Guatemala");
            lista.Add("asdfafd");

            lista.Remove("hola mundo");

            for (int i = 0; i < lista.Count; i++)
            {
                
            }

            // Colecciones

            Collection<long> coleccion = new Collection<long>();

            coleccion.Add(100);
            coleccion.Add(100);
            coleccion.Add(100);

            coleccion.Remove(100);

            foreach (var item in coleccion)
            {
                //Console.WriteLine(item);
            }


            //Console.ReadLine();



            var persona1 = new Persona("Pedro");
            var persona2 = new Persona("Juan");
            var persona3 = new Persona("Pablo");

            List<Persona> personas = new List<Persona>()
            {
                persona2, persona1, persona3
            };
        
            personas.Sort();

            for (int i = 0; i < personas.Count; i++)
            {
                Persona item = personas[i];
                Console.WriteLine(item.Nombres);
            }

            foreach (var item in personas)
            {
                Console.WriteLine(item.Nombres);
            }

            Console.ReadLine();

        }
    }
}