﻿using Consola.Contratos;
using Consola.Dominio;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Consola.Servicios
{
    class ServicioPersonaEnMemoria : IServicioPersona
    {

        private List<Persona> personas = new List<Persona>();

        public Dominio.Persona[] ObtenerTodas()
        {
            return personas.ToArray();
        }

        public int Crear(Dominio.Persona persona)
        {
            personas.Add(persona);
            return personas.Count;
        }

        public void Editar(Dominio.Persona persona)
        {
            //
        }

        public void Eliminar(Dominio.Persona persona)
        {
            personas.Remove(persona);
        }

        public Dominio.Persona ObtenerUnica(int id)
        {
            return personas.First();
        }
    }
}
